
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Campaign_recipientsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const campaign_recipients = await db.campaign_recipients.create(
            {
                id: data.id || undefined,
        
        delivery_status: data.delivery_status
        ||
        null
            ,
            
        delivered_at: data.delivered_at
        ||
        null
            ,
            
        provider_reference: data.provider_reference
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await campaign_recipients.setCampaign( data.campaign || null, {
            transaction,
        });
        
        await campaign_recipients.setCustomer( data.customer || null, {
            transaction,
        });
        
        await campaign_recipients.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return campaign_recipients;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const campaign_recipientsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                delivery_status: item.delivery_status
            ||
            null
            ,
            
                delivered_at: item.delivered_at
            ||
            null
            ,
            
                provider_reference: item.provider_reference
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const campaign_recipients = await db.campaign_recipients.bulkCreate(campaign_recipientsData, { transaction });

        // For each item created, replace relation files
        

        return campaign_recipients;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const campaign_recipients = await db.campaign_recipients.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.delivery_status !== undefined) updatePayload.delivery_status = data.delivery_status;
        
        
        if (data.delivered_at !== undefined) updatePayload.delivered_at = data.delivered_at;
        
        
        if (data.provider_reference !== undefined) updatePayload.provider_reference = data.provider_reference;
        
        
        updatePayload.updatedById = currentUser.id;

        await campaign_recipients.update(updatePayload, {transaction});

        
        
        if (data.campaign !== undefined) {
            await campaign_recipients.setCampaign(
              
              data.campaign,
              
              { transaction }
            );
        }
        
        if (data.customer !== undefined) {
            await campaign_recipients.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await campaign_recipients.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return campaign_recipients;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const campaign_recipients = await db.campaign_recipients.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of campaign_recipients) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of campaign_recipients) {
                await record.destroy({transaction});
            }
        });


        return campaign_recipients;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const campaign_recipients = await db.campaign_recipients.findByPk(id, options);

        await campaign_recipients.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await campaign_recipients.destroy({
            transaction
        });

        return campaign_recipients;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const campaign_recipients = await db.campaign_recipients.findOne(
            { where },
            { transaction },
        );

        if (!campaign_recipients) {
            return campaign_recipients;
        }

        const output = campaign_recipients.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.campaign = await campaign_recipients.getCampaign({
            transaction
        });
        
        
        output.customer = await campaign_recipients.getCustomer({
            transaction
        });
        
        
        output.organizations = await campaign_recipients.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.marketing_campaigns,
        as: 'campaign',
        
        where: filter.campaign ? {
          [Op.or]: [
            { id: { [Op.in]: filter.campaign.split('|').map(term => Utils.uuid(term)) } },
            {
              campaign_name: {
                [Op.or]: filter.campaign.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              customer_name: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.provider_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'campaign_recipients',
                        'provider_reference',
                        filter.provider_reference,
                    ),
                };
            }
            

            
            

            
            if (filter.delivered_atRange) {
                const [start, end] = filter.delivered_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.delivery_status) {
                where = {
                    ...where,
                delivery_status: filter.delivery_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.campaign_recipients.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'campaign_recipients',
                        'provider_reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.campaign_recipients.findAll({
            attributes: [ 'id', 'provider_reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['provider_reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.provider_reference,
        }));
    }

    
};

